<?php

/**
 * Shiroi
 * @package ShiroiConsole
 * @author shiroi
 * @version 1.0.0
 * @link https://shiroi.top
 */
class ShiroiConsole_Plugin implements Typecho_Plugin_Interface
{
    public static function personalConfig(Typecho_Widget_Helper_Form $form)
    {
    }

    public static function deactivate()
    {
    }

    /**
     * 引入配置
     * @param Typecho_Widget_Helper_Form $form
     */
    public static function config(Typecho_Widget_Helper_Form $form)
    {
        //打印的内容
        $shiroiConsoleContent = new Typecho_Widget_Helper_Form_Element_Text('shiroiConsoleContent', NULL, '欢迎来到shiroi的博客', _t('f12 console打印的个性昵称'), _t('f12 console打印的个性昵称'));
        $form->addInput($shiroiConsoleContent);
        //颜色
        $shiroiConsoleColor = new Typecho_Widget_Helper_Form_Element_Text('shiroiConsoleColor', NULL, 'red', _t('颜色'), _t('颜色'));
        $form->addInput($shiroiConsoleColor);
        //背景
        $shiroiConsoleBackground = new Typecho_Widget_Helper_Form_Element_Text('shiroiConsoleBackground', NULL, 'red', _t('背景'), _t('背景'));
        $form->addInput($shiroiConsoleBackground);
        //圆角边框
        $shiroiConsoleBorderRadius = new Typecho_Widget_Helper_Form_Element_Text('shiroiConsoleBorderRadius', NULL, '3px 0 0 3px', _t('圆角边框'), _t('圆角边框'));
        $form->addInput($shiroiConsoleBorderRadius);
        //字体尺寸
        $shiroiConsoleSize = new Typecho_Widget_Helper_Form_Element_Text('shiroiConsoleSize', NULL, '5em', _t('字体尺寸'), _t('字体尺寸'));
        $form->addInput($shiroiConsoleSize);
        //阴影
        $shiroiConsoleTextShadow = new Typecho_Widget_Helper_Form_Element_Text('shiroiConsoleTextShadow', NULL, '0 1px 0 red,0 2px 0 #c9c9c9,0 3px 0 #bbb,0 4px 0 #b9b9b9,0 5px 0 #aaa,0 6px 1px rgba(0,0,0,.1),0 0 5px rgba(0,0,0,.1),0 1px 3px rgba(0,0,0,.3),0 3px 5px rgba(0,0,0,.2),0 5px 10px rgba(0,0,0,.25),0 10px 10px rgba(0,0,0,.2),0 20px 20px rgba(0,0,0,.15)', _t('阴影'), _t('阴影'));
        $form->addInput($shiroiConsoleTextShadow);
    }

    /**
     * 激活插件
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function activate()
    {
        //设置console打印的名字
        Typecho_Plugin::factory('admin/menu.php')->navBar = array('Shiroi_Plugin', 'render');
        //载入footer资源
        Typecho_Plugin::factory('Widget_Archive')->footer = array('ShiroiConsole_Plugin', 'footer');
    }

    /**
     * 生成console内容
     * @return string
     */
    public static function createConsole()
    {
        $shiroiConsoleContent = self::toValue('shiroiConsoleContent');
        $shiroiConsoleColor = self::toValue('shiroiConsoleColor')?'color:'.self::toValue('shiroiConsoleColor').';':'';
        $shiroiConsoleBackground = self::toValue('shiroiConsoleBackground')?'background:'.self::toValue('shiroiConsoleBackground').';':'';
        $shiroiConsoleBorderRadius = self::toValue('shiroiConsoleBorderRadius')?'border-radius:'.self::toValue('shiroiConsoleBorderRadius').';':'';
        $shiroiConsoleSize = self::toValue('shiroiConsoleSize')?'font-size:'.self::toValue('shiroiConsoleSize').';':'';
        $shiroiConsoleTextShadow = self::toValue('shiroiConsoleTextShadow')?'text-shadow:'.self::toValue('shiroiConsoleTextShadow').';':'';
        return "console.log('%c{$shiroiConsoleContent}','{$shiroiConsoleColor}{$shiroiConsoleBackground}{$shiroiConsoleBorderRadius}{$shiroiConsoleSize}{$shiroiConsoleTextShadow}')";
    }

    /**
     * 值返回
     * @param $value
     * @return string
     * @throws Typecho_Exception
     */
    public static function toValue($value)
    {
        return htmlspecialchars(Typecho_Widget::widget('Widget_Options')->plugin('ShiroiConsole')->$value);
    }

    /**
     * 尾部
     */
    public static function footer()
    {
        echo '<script type="text/javascript">'.self::createConsole().'</script>';
    }
}